﻿using HeuristicLab.Common;
using HeuristicLab.Optimization;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.SimulationCore {
  [StorableClass]
  public abstract class Reporter<TModel> : IReporter<TModel> where TModel : IModel {

    [StorableConstructor]
    protected Reporter(bool deserializing) { }
    protected Reporter(Reporter<TModel> original, Cloner cloner) {
      cloner.RegisterClonedObject(original, this);
    }
    protected Reporter() { }

    public abstract void UpdateReporting(TModel model, ResultCollection results);

    public object Clone() { return Clone(new Cloner()); }
    public abstract IDeepCloneable Clone(Cloner cloner);
  }
}
